<?php 
/*
 * Zhixun API PHP Web 示例
 * http://www.likexian.com/
 *
 * Copyright 2016, t1789.com
 * Released under the Apache License, Version 2.0
 *
 */
class zhixun {
	public $url;
	public $Akey;
	
	public function __construct($url = false,$key = false) {
		if(!$url) {
			$this ->url = "http://www.t1789.com/api.php?home=";
		}else {
			$this ->url = $url."/api.php?home=";
		}
		if(!$key) {
			$this -> Akey = 't1599.com';
		}else {
			$this -> Akey = $key;
		}
	}
	
	public function encrypt($data) { 
		$base_key   =   md5($this->Akey); 
		$x      	=   0;  
		$len    	=   strlen($data);  
		$l      	=   strlen($base_key);  
		for ($i = 0; $i < $len; $i++) {  
			if ($x == $l) {  $x = 0;  	}
			$char .= $base_key{$x};  
			$x++;  
		}  
		for ($i = 0; $i < $len; $i++) {  
			$str .= chr(ord($data{$i}) + (ord($char{$i})) % 256); 
		}
		return base64_encode($str);  
	}
	public function crypt_post($post_data) {
		foreach($post_data as $tag =>$V) {
			if($tag != 'uid')	{
				$post_data[$tag] = encrypt($V);
			}
		}
		return $post_data;
	}
	
	public function arrayRecursive(&$array, $function, $apply_to_keys_also = false) {  
		static $recursive_counter = 0;
		if (++$recursive_counter > 1000) {  
			die('possible deep recursion attack');
		}
		foreach ($array as $key => $value) {  
			if (is_array($value)) { 
				$this ->arrayRecursive($array[$key], $function, $apply_to_keys_also);
			} else { 
				$array[$key] = $function($value);
			} 
			if ($apply_to_keys_also && is_string($key)) {  $new_key = $function($key);
				if ($new_key != $key) {  $array[$new_key] = $array[$key];
					unset($array[$key]);
				} 
			} 
		} 
		$recursive_counter--;
	}
	// * 将数组转换为JSON字符串（兼容中文）*
	// * @param array $array 要转换的数组 *
	// * @return string 转换得到的json字符串 *
	// * @access public 
	/**/
	public function JSON($array) {  
		$this ->arrayRecursive($array,'urlencode',true);
		$json = json_encode($array);
		return urldecode($json);
	}
	private function start_work($url,$post_data=false,$cookie='') {
		if ($url == '') {	exit('内部错误：参数错误');			}
		$ch = curl_init(); //初始化一个CURL对象
		if (!$ch)		{	exit( '内部错误：服务器不支持CURL');	}
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSLVERSION, 1);
		if(!empty($cookie)) { 
			curl_setopt($ch, CURLOPT_COOKIE, $cookie);
		}
		//	$post_data = crypt_post($post_data);
		if(!empty($post_data)) {
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
		}
        curl_setopt($ch, CURLOPT_USERAGENT, 'zhixun API PHP Web Client');
		$result = curl_exec($ch);
		curl_close($ch);
		return $result;
	}
	
	public function tran_error($data) {
		
	}
	public function start_reg($userid,$passwd) {  
		$post_data = array ("userid" => $userid,
							"passwd" => $passwd);
		$url  = $this ->url."reg";
		$data = $this ->start_work($url, $post_data);
		return $data;
	}
	
	
	public function start_login($userid,$passwd) {
		$post_data = array ("userid" => $userid,
							"passwd" => $passwd);
		$url  = $this ->url."login";
		$data = $this ->start_work($url, $post_data);
		return $data;
	}
	
	public function read_data($post_data) {
		$url  = $this ->url."readdata";
		$data = $this ->start_work($url, $post_data);
		return $data;
	}
	
	public function renew_base($post_data) {
		$url  = $this ->url."renewbase";
		$data = $this ->start_work($url, $post_data);
		return $data;
	}
	
	public function clear_data($post_data) {  //type a web_class b web_subclass c web_url d web_sites
		$url  = $this ->url."cleardata";
		if(is_array($post_data['data'])){
			$post_data['data'] =$this ->JSON($post_data['data']);
		}
		
		$data = $this ->start_work($url, $post_data);
		return $data;
	}
	
	public function add_list($post_data) {  //type a web_class b web_subclass c web_url d web_sites
		if(is_array($post_data['data'])) {
			$post_data['data'] =$this ->JSON($post_data['data']);
		}
		$url = $this ->url."addlist";
		$data = $this ->start_work($url, $post_data);
		return $data;

	}
	
	public function add_sites($post_data) { 
		if(is_array($post_data['data'])) {
			$post_data['data'] =$this ->JSON($post_data['data']);
		}
		$url  = $this ->url."addsites";
		$data = $this ->start_work($url, $post_data);
		return $data;
	}	
	
}
?>